
var restClient = require('../index').restClient;
var clientMessage = require('postchain-client').clientMessage;
var gtx = require('postchain-client').gtxClient;

describe('Ratatosk backend integration test manual', function () {
    this.timeout(8000);
    it('R2 getMessages external nodes', (done) => {
        var rest = restClient.createRestClient(`http://35.157.104.6/podchain/2/`);
        // var restClient = re
        var gtxClient = gtx.createClient(rest, ['R2createChain', 'R2postMessage']);

        // Get a nonce
        gtxClient.query({type: "getNonce"}, (error, response) => {
            if (error) reject(error);
            resolve(response);
        })

        // Post two messages atomically to the chain
        var payload1 = Buffer.from('first atomic', 'utf8');
        var payload2 = Buffer.from('second atomic', 'utf8');
        var payload3 = Buffer.from('third atomic', 'utf8');
        var chainId = messageId(nonce, payload1, [pubKeyA, pubKeyB]);
        var messageId2 = messageId(chainId, payload2, [pubKeyA, pubKeyB]);
        var messageId3 = messageId(messageId2, payload3, [pubKeyA, pubKeyB]);

        var req = gtxClient.newRequest([pubKeyA, pubKeyB]);
        req.R2createChain(nonce, payload1);
        req.R2postMessage(chainId, payload2);
        req.R2postMessage(messageId2, payload3);
        req.sign(privKeyB);
        req.sign(privKeyA);
        req.send(error => {
            if (error) {
                assert.fail();
            } else {
                done()
            }
        });
    });

    function send(req) {
        new Promise((resolve, reject) => {
            req.send(error => reject(error));
        });
    }

    function hex(buffer) {
        return buffer.toString('hex');
    }

    function buf(hex) {
        return Buffer.from(hex, 'hex');
    }

    function messageId(prevId, payload, signers) {
        return util.hash256(Buffer.concat([prevId, payload, Buffer.concat(signers)]));
    }

})


